#!/bin/bash
which mpcrun
if [ $? == 1 ]; then
  echo "ERROR: mpi not found in your path."
  echo "Please load the mpi module and retry."
fi
MPI_ROOT=mpc_gnu

mkdir -p movies
if [ -x ./sweqx-$MPI_ROOT ]; then
    echo "Running with MPI using -n=12 -p=12"
    /bin/rm -f run_np_${MPI_ROOT}.log run_p1_${MPI_ROOT}.log
    time mpcrun -n=12 -p=12 -net=tcp ./sweqx-$MPI_ROOT < ./homme1_3_6/test/sw_conservative/swtc1.nl | tee run_np_${MPI_ROOT}.log
    echo "Running with MPI using -n=12 -p=1"
    time mpcrun -n=12 -p=1 ./sweqx-$MPI_ROOT < ./homme1_3_6/test/sw_conservative/swtc1.nl | tee run_p1_${MPI_ROOT}.log
fi

