#!/bin/bash
which mpirun
if [ $? == 1 ]; then
  echo "ERROR: mpi not found in your path."
  echo "Please load the mpi module and retry."
fi
MPI_ROOT=ompi

mkdir -p movies
if [ -x ./sweqx-$MPI_ROOT ]; then
    echo "Running with MPI using -np 12"
    /bin/rm -f run_${MPI_ROOT}.log
    time mpirun -np 12 ./sweqx-$MPI_ROOT < ./homme1_3_6/test/sw_conservative/swtc1.nl | tee run_${MPI_ROOT}.log
fi

